//+-----------------------------------------------------------------------+
//|                                                   ADX MTF Candles.mq4 |
//|  original candle code by mikkom adapted by cja for tsd forum Jan 2011 |
//+-----------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Lime
#property indicator_color3 Red
#property indicator_color4 Lime
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 4
#property indicator_width4 4


extern int    Timeframe    = 0;
extern int    ADXPeriod    = 2;


string TF;

double red[];
double redBody[];
double greenBody[];
double green[];

int init() {

   IndicatorBuffers(4);
   SetIndexBuffer(0, red);   
   SetIndexStyle(0, DRAW_HISTOGRAM); 

   SetIndexBuffer(1, green);     
   SetIndexStyle(1, DRAW_HISTOGRAM);
   
   SetIndexBuffer(2, redBody);     
   SetIndexStyle(2, DRAW_HISTOGRAM);
   
   SetIndexBuffer(3, greenBody);     
   SetIndexStyle(3, DRAW_HISTOGRAM);
   
   
   IndicatorShortName("ADX MTF "+ADXPeriod+"/"+Timeframe);
   
   
   	   	switch(Timeframe)
	{
		case 1:		TF="M1";  break;
		case 5:		TF="M5";  break;
		case 15:		TF="M15"; break;
		case 30:		TF="M30"; break;
		case 60:		TF="H1";  break;
		case 240:	TF="H4";  break;
		case 1440:	TF="D1";  break;
		case 10080:	TF="W1";  break;
		case 43200:	TF="MN1"; break;
		default:	  {Timeframe = Period(); init(); return(0);}
	}
	
   
   if(Timeframe == 0)
      Timeframe = Period();
      
   return(0);
}
  
int deinit() {

   ObjectDelete("adx_tf");
   return(0);
}
     
int start() {
   
   int counted_bars=IndicatorCounted();
  
   if(counted_bars < 0) 
       return(-1);
   if(counted_bars > 0) 
       counted_bars--;
       
   int limit = Bars - counted_bars;
   for(int i = limit; i >= 0; i--) {

      int s = iBarShift(Symbol(), Timeframe, Time[i], true);
      
      double nowplusdi=iADX(NULL,Timeframe,ADXPeriod,PRICE_CLOSE,MODE_PLUSDI,s);
     
      double nowminusdi=iADX(NULL,Timeframe,ADXPeriod,PRICE_CLOSE,MODE_MINUSDI,s);
     
      if(nowplusdi > nowminusdi) {
         green[i] = High[i];      
         red[i] = Low[i];  

         greenBody[i] = MathMax(Open[i], Close[i]);      
         redBody[i] = MathMin(Open[i], Close[i]);
       
      }
      if(nowplusdi < nowminusdi) {
      
         red[i] = High[i];      
         green[i] = Low[i];  

         redBody[i] = MathMax(Open[i], Close[i]);      
         greenBody[i] = MathMin(Open[i], Close[i]);
       
      }
      
       Createtext( "adx_tf",10,5);
       ObjectSetText("adx_tf","ADX Candles TF : "+TF, 12, "Vendana", Silver);
 
     
   }
  return(0);
}

 int Createtext( string a, int x, int y ) {
   ObjectCreate( a, OBJ_LABEL,0, 0, 0 );
   ObjectSet( a, OBJPROP_CORNER, 2 );
   ObjectSet( a, OBJPROP_XDISTANCE,x);
   ObjectSet( a, OBJPROP_YDISTANCE,y);
   ObjectSet( a, OBJPROP_BACK, false );
   }
   




